package repository

import (
	"fmt"
	"strings"

	"be.ems/src/framework/datasource"
	"be.ems/src/framework/logger"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/utils/repo"
	"be.ems/src/modules/network_data/model"
)

// 实例化数据层 UDMUserInfo 结构体
var NewUDMUserInfo = &UDMUserInfo{
	selectSql: `select id, imsi, msisdn, ne_id, remark  from u_user_info`,

	resultMap: map[string]string{
		"id":     "ID",
		"imsi":   "IMSI",
		"msisdn": "MSISDN",
		"ne_id":  "NeId",
		"remark": "Remark",
	},
}

// UDMUserInfo UDM鉴权信息表 数据层处理
type UDMUserInfo struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *UDMUserInfo) convertResultRows(rows []map[string]any) []model.UDMUserInfo {
	arr := make([]model.UDMUserInfo, 0)
	for _, row := range rows {
		item := model.UDMUserInfo{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// SelectPage 根据条件分页查询
func (r *UDMUserInfo) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["imsi"]; ok && v != "" {
		conditions = append(conditions, "imsi like concat(concat('%', ?), '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["neId"]; ok && v != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, v)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.UDMUserInfo{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(1) as 'total' from u_user_info"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 排序
	orderSql := ""
	if v, ok := query["sortField"]; ok && v != "" {
		sortSql := v.(string)
		if o, ok := query["sortOrder"]; ok && o != nil && v != "" {
			if o == "desc" {
				sortSql += " desc "
			} else {
				sortSql += " asc "
			}
		}
		orderSql = fmt.Sprintf(" order by %s ", sortSql)
	}

	// 查询数据
	querySql := r.selectSql + whereSql + orderSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *UDMUserInfo) SelectList(u model.UDMUserInfo) []model.UDMUserInfo {
	// 查询条件拼接
	var conditions []string
	var params []any
	if u.IMSI != "" {
		conditions = append(conditions, "imsi = ?")
		params = append(params, u.IMSI)
	}
	if u.NeId != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, u.NeId)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by imsi asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIMSIAndNeID 通过imsi和ne_id查询
func (r *UDMUserInfo) SelectByIMSIAndNeID(imsi, neId string) model.UDMUserInfo {
	querySql := r.selectSql + " where imsi = ? and ne_id = ?"
	results, err := datasource.RawDB("", querySql, []any{imsi, neId})
	if err != nil {
		logger.Errorf("query err => %v", err)
		return model.UDMUserInfo{}
	}
	// 转换实体
	rows := r.convertResultRows(results)
	if len(rows) > 0 {
		return rows[0]
	}
	return model.UDMUserInfo{}
}

// Insert 批量添加
func (r *UDMUserInfo) Inserts(uArr []model.UDMUserInfo) int64 {
	tx := datasource.DefaultDB().CreateInBatches(uArr, 3000)
	if err := tx.Error; err != nil {
		logger.Errorf("CreateInBatches err => %v", err)
	}
	return tx.RowsAffected
}

// Delete 删除实体
func (r *UDMUserInfo) Delete(imsi, neId string) int64 {
	tx := datasource.DefaultDB().Where("imsi = ? and ne_id = ?", imsi, neId).Delete(&model.UDMUserInfo{})
	if err := tx.Error; err != nil {
		logger.Errorf("Delete err => %v", err)
	}
	return tx.RowsAffected
}

// DeletePrefixByIMSI 删除前缀匹配的实体
func (r *UDMUserInfo) DeletePrefixByIMSI(imsiPrefix, neId string) int64 {
	tx := datasource.DefaultDB().Where("imsi like concat(?, '%') and ne_id = ?", imsiPrefix, neId).Delete(&model.UDMUserInfo{})
	if err := tx.Error; err != nil {
		logger.Errorf("DeletePrefixByIMSI err => %v", err)
	}
	return tx.RowsAffected
}
